//
//  MSConstants.h
//  Dictate
//
//  Created by Eric Hon-Anderson on 9/4/07.
//  Copyright 2007-2009 MacSpeech, Inc. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#pragma mark -
#pragma mark Our files' extensions
#pragma mark -
extern NSString * kV9ProfileExtension;

extern NSString * kSpeechEngDataFolder;

extern NSString *kDictateBundleID;
extern NSString *kDictateLegalBundleID;
extern NSString *kDictateMedicalBundleID;

extern NSString *kScribeBundleID;
extern NSString *kScribeLegalBundleID;
extern NSString *kScribeMedicalBundleID;

extern NSString *kPodiumBundleID;
extern NSString *kPodiumLegalBundleID;
extern NSString *kPodiumMedicalBundleID;

// internnational bundle ids
extern NSString *kDictateInternationalBundleID;
extern NSString *kScribeInternationalBundleID;
extern NSString *kPodiumInternationalBundleID;

// regionals
extern NSString *kDictateFrenchBundleID;
extern NSString *kDictateGermanBundleID;
extern NSString *kDictateItalianBundleID;

extern NSString *kScribeFrenchBundleID;
extern NSString *kScribeGermanBundleID;
extern NSString *kScribeItalianBundleID;

extern NSString *kPodiumFrenchBundleID;
extern NSString *kPodiumGermanBundleID;
extern NSString *kPodiumItalianBundleID;

// packages
extern NSString  *MSEnglishesPak;
extern NSString  *MSEuroPak;
extern NSString  *MSMedicalPak;
extern NSString  *MSLegalPak;
extern NSString  *MSTheWorksPak;
// defined & set to one of the above in the prefix file, this is how we can distinguish packages at runtime.
extern NSString  *MSCurrentPak;

// special AX attribute we use to keep track of our windows and the associated clients through AX
extern const NSString * MSDictateWindowClientAXAttribute;

// preferences
#if kPodium
extern NSString * MSPrefKnownProfiles;
#endif
#if kTranscriptionOnly
extern NSString * MSPrefLastTranscriptionMode;
extern NSString * MSPrefLastNotePadCorrectionSidebarWidth;
extern NSString * MSPrefLastNotePadCorrectionSidebarCollapsedState;
extern NSString * MSScribeSupportsMP3s;
#endif
extern NSString * MSPrefAcceptedEULA;
extern NSString * MSPrefAutosaveDelay;
extern NSString * MSPrefComputeSpeed;
extern NSString * MSPrefCurrentProfile;
extern NSString * MSPrefDebugAlwaysShowStoryChoicePanel;
extern NSString * MSPrefDebugDisableCFGs;
extern NSString * MSPrefDebugLogRecognitions;
extern NSString * MSPrefDebugNoZombies;
extern NSString * MSPrefDebugPlaybackRecognitions;
extern NSString * MSPrefDebugShowGainScale;
extern NSString * MSPrefDebugValidateDictationDocument;
extern NSString * MSPrefDebugVoiceTraining;
extern NSString * MSPrefDoNotObserveApplications;
extern NSString * MSPrefEnableDictComd;
extern NSString * MSPrefEnableEmailCommands;
extern NSString * MSPrefGainScale;
extern NSString * MSPrefMaxSelectWordsSize;
/*extern NSString * MSPrefCacheWarningWordsSize;
extern NSString * MSPrefShowCacheSizeWarning;*/
extern NSString * MSPrefShowGFAlerts;
extern NSString * MSPrefShowTrainTextMacroWarning;
extern NSString * MSPrefMicIsOn;
extern NSString * MSPrefNoSplash;
extern NSString * MSPrefNumCorrectionAlternatives;
extern NSString * MSPrefOpenNotePadAtStartup;
extern NSString * MSPrefOpenWelcomeWindow;
extern NSString * MSPrefPrintNuanceWarnings;
extern NSString * MSPrefProcessSwitchFactor;
extern NSString * MSPrefReadMeDisplayed;
extern NSString * MSPrefSaveResultAudio;
extern NSString * MSPrefShowAvailableCommandsAtStartup;
extern NSString * MSPrefShowDebugMenu;
extern NSString * MSPrefShowDebugPanel;
extern NSString * MSPrefShowFeedbackAtStartup;
extern NSString * MSPrefShowProfilesAtStartup;  // actually it's Splash, not Profiles
extern NSString * MSPrefShowStatusItem;
extern NSString * MSPrefShowDockBadge;
extern NSString * MSPrefDebugLogFullText;

//extern NSString * MSPrefHideMicrophoneUsageInfo;
// not going to allow supression of this one:
// extern NSString * MSPrefHideUncertifiedMicUsageInfo;
extern NSString * MSPrefHideBluetoothMicUsageInfo;
extern NSString * MSPrefHideUSBDongleUsageInfo;
extern NSString * MSPrefHideUSBMicUsageInfo;
#if PRERELEASE
extern NSString * MSPrefDebugSpoofCalisto;
#endif

extern NSString * MSPrefShowRecognizedText;
extern NSString * MSPrefTrainDuration;
extern NSString * MSPrefTrainWholeStory;
extern NSString * MSPrefUpdateCheckAtStartup;
extern NSString * MSPrefUseNewProfileUI;
extern NSString * MSPrefStatusAlpha;
extern NSString * MSLastSelectedPreferencePaneIdentifier;
extern NSString * MSTranscriptionTrainingFontSize;
extern NSString * MSTranscriptionTrainingLastEditorVolume;

// Text Control preferences
extern NSString * MSPrefUsePagesTextControl;
extern NSString * MSPrefUseiChatTextControl;
extern NSString * MSPrefNoInitialCacheList;

extern NSString * MSPrefShowCorrectionAfterEachRecognition;
//extern NSString * MSPrefShowCorrectionInFeedback;
extern NSString * MSPrefCloseCorrectionAfterChoosing;
extern NSString * MSPrefCorrectionAlpha;

extern NSString * MSPrefMicHotKeyEvent;
extern NSString * MSPrefSpeechModeMicHotKeyEvent;
extern NSString * MSPrefCorrectionHotKeyEvent;

extern NSString * MSPrefModeAtLaunch;

extern NSString * MSLastNotepadAttributes;

extern NSString * MSPrefBluetoothEnabled;
extern NSString * MSPrefBuiltInEnabled;
extern NSString * MSPrefiPhoneEnabled;

extern NSString * MSPrefFatalErrorAction;
extern NSString * MSPrefTextValidationErrorsAreFatalErrors;

extern NSString * MSOutOfSyncTitle;
extern NSString * MSOutOfSyncMessage;

extern NSString * MSMultiBytePresentWarningTitle;
extern NSString * MSMultiBytePresentWarningMessage;

// commands related prefs
extern NSString *MSDisableActiveCommands;
extern NSString *MSPrefGroupCommands;
extern NSString *MSPrefGlobalCommandsAtTop;
extern NSString *MSPrefGroupGlobalCommands;
extern NSString *MSPrefGenerateApplicationCommands;
extern NSString *MSPrefGenerateBookmarkCommands;
extern NSString *MSPrefGenerateEmailCommands;
extern NSString *MSPrefWebCommands;

// available commands
extern NSString *MSPrefsAvailableCommandsOpen;
extern NSString *MSPrefsACWindowIsVisible;
extern NSString *MSPrefsInhibitSpokenCommandAlert;
extern NSString *kWebGroupNameKey;

// RecEvents
extern NSString *MSPrefRecEventsEnabled;

// Profiles UI setup.
extern NSString* MSPrefLanguageSelection;
extern NSString* MSPrefAccentSelection;

// tracks available commands group disclosure states
extern NSString *MSCommandGroupDisclosureStates;

// Some notifications constants for our internal communications.
extern const NSString * MSNotificationTranscribePercentCompleted;
extern const NSString * MSNotificationTranscribeChannelDied;
extern const NSString * MSNotificationTranscriptionCompleted;

extern const NSString * MSNotificationCreatedInterface;
extern const NSString * MSNotificationDeletingInterface;
extern const NSString * MSNotificationDidLoadUser;
extern const NSString * MSNotificationWillUnloadUser;
extern const NSString * MSNotificationGlobalGrammarsEnabled;
extern const NSString * MSNotificationAtEndOfInput;
extern const NSString * MSNotificationPhoneCommandsChanged;

extern const NSString * kDeadChannelKey;
extern const NSString * kPercentDoneKey;

// CoreAudio notification constants
extern NSString* kDeviceMissingKey;
extern NSString* kDeviceDiedKey;
extern NSString* kDevicesChangedKey;
extern NSString* kConfigChangedKey;
extern NSString* kStreamsChangedKey;
extern NSString* kTheDeviceChangedKey;
extern NSString* kSomebodysHoggingKey;

// these are faux modes, not suitable for setMode
extern const NSString * MSModeIdle;
extern const NSString * MSModeCorrection;

// these are real modes and can be passed to setMode
extern const NSString * MSModeDictation;
extern const NSString * MSModeCommand;
extern const NSString * MSModeSpelling;
extern const NSString * MSModeSetUpMyMic;
extern const NSString * MSModeLearnMyVoice;
extern const NSString * MSModePronounce;
extern const NSString * MSModeLearnMyWritingStyle;
extern const NSString * MSModeWelcomeWindow;

#pragma mark -
#pragma mark Profiles' Descriptor Keys

// final state for profile - SetUpMyMic & LearnMyVoice being the other two states as of now
extern const NSString * MSProfileOperational;

// special mode
extern const NSString * MSModeAsleep;

// Transcription versus Live profile modes
extern const NSString * MSTranscriptionOnly;
extern const NSString * MSLiveOnly;
extern const NSString * MSLiveAndTranscription;

extern const NSString* kOldNameKey;
extern const NSString* kNameKey;
extern const NSString* kNuanceNameKey;
extern const NSString* kLanguageIDKey;
extern const NSString* kAcousticsKey;
extern const NSString* kTopicKey;
extern const NSString* kDeviceKey;
extern const NSString* kIsBuiltinKey;
extern const NSString* kIsUncertifiedKey;
extern const NSString* kGainKey;
extern const NSString* kCreationDateKey;
extern const NSString* kLastUsedKey;
extern const NSString* kModificationDataKey;
extern const NSString* kIsTranscriptionKey;
extern const NSString* kProfileStateKey;
extern const NSString* kProfileVersionKey;
extern const NSString* kPackageKey;
extern const NSString* kUserPictureKey;
extern const NSString* kManualGainModeKey;
extern const NSString* kProfileGainKey;

#pragma mark End Profiles' Descriptor Keys
#pragma mark -

extern const NSString * kMSSpellingGrammar_MainRuleName;

// unique commandid for emailComposer CFG
extern const int emailComposerCommandID;

// Usage Note Keys
extern const NSString *kUsageNoteDisplayName;
extern const NSString *kUsageNoteExplanation;
extern const NSString *kUsageNoteExamples;
extern const NSString *kUsageNotePhrases;
extern const NSString *kUsageNoteTarget;

// Logging Level
extern const NSString *MSLoggingLevel;

// Undo/Redo Action Names
extern const NSString * MSUndoRedoDictation;

// Not Implemented Error Message
extern const NSString * MSScratchThatNotImplemented;

#pragma mark -

extern NSString * MSEnableCorrectionChanged;
extern NSString * MSCorrectionAlternativesChanged;

#pragma mark -
#pragma mark RecEvent Versioning
extern NSString *MSRecEventVersion;
extern NSString *MSRecEventDefaultVersion;
extern NSString *MSRecEventLatestVersion;
